<!DOCTYPE html>
<html>
  <head>
    <meta charset="UTF-8" />
    <title>Type Ahead</title>
    <link rel="stylesheet" href="./style.css" />
  </head>
  <body>
    <form class="search-form">
      <input type="text" class="search" placeholder="City or State" />
      <ul class="suggestions">
        <li>Filter for a city</li>
        <li>or state</li>
      </ul>
    </form>

    <script>
      const endpoint =
        "https://gist.githubusercontent.com/Miserlou/c5cd8364bf9b2420bb29/raw/2bf258763cdddd704f8ffd3ea9a3e81d25e2c6f6/cities.json";
      const cities = [];

      fetch(endpoint)
        .then((blob) => blob.json())
        .then((data) => cities.push(...data));

      //
      function findMatches(matchedWord, cities) {
        return cities.filter((place) => {
          const regex = new RegExp(matchedWord, "gi");
          return place.city.match(regex) || place.state.match(regex);
        });
      }

      function numberWithCommas(x) {
        return x.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ",");
      }

      function displayMatches() {
        // input 에서 나온 value == 검색 결과
        const searchPhrase = this.value;

        // 필터링 결과는 배열
        const matchArray = findMatches(searchPhrase, cities);

        const html = matchArray
          .map((place) => {
            const regexHi = new RegExp(this.value, "gi");

            // 도시 이름의 문자열을 html 태그로 바꿈
            const cityName = place.city.replace(regexHi, `<span class="hl">${this.value}</span>`);

            const cityState = place.state.replace(regexHi, `<span class="hl">${this.value}</span>`);

            // 최종 정리 태그
            return `<li>
            <span class="name">${cityName}, ${cityState}</span>
            <span class="population">${numberWithCommas(place.population)}</span>
            </li>`;
          })
          .join("");

        suggestions.innerHTML = html;
      }

      const searchInput = document.querySelector(".search");
      const suggestions = document.querySelector(".suggestions");

      searchInput.addEventListener("change", displayMatches);
      searchInput.addEventListener("keyup", displayMatches);
    </script>
  </body>
</html>
